#!/bin/env ruby
#
# (C) Gustavo De Nardin, 2008
#
# Permission is granted for use, copying, modification, distribution,
# and distribution of modified versions of this work as long as the
# above copyright notice is included. No warranty of any sort.
#
# Permissão concedida para uso, cópia, alteração, distribuição, e
# distribuição de alterações desta obra, contanto que a atribuição de
# direito autoral acima seja mantida. Sem garantia de qualquer tipo.
#
# (I'd simply put this in Public Domain, but Brazilian law doesn't seem to
# allow it :], so a permissive (C) is safer...) References:
# <http://blade.nagaokaut.ac.jp/cgi-bin/scat.rb/ruby/ruby-talk/24759>
# <http://fedoraproject.org/wiki/Licensing/CopyrightOnly>

require "rpm"

USAGE=<<FIN

Usage:
#{$0.split("/").last} version-string|rpm-file version-string|rpm-file

Outputs the higher version.

FIN


def argv_ver(argv)
  if File.exists?(argv)
    begin
      rpm_f = RPM::Package.open(argv)
    rescue => x
      STDERR.puts USAGE
      STDERR.puts "Error opening file '#{argv}': #{x}"
      exit 1
    end
    e = rpm_f.version.e
    v = rpm_f.version.v
    r = rpm_f.version.r
    ver = ""
    ver << e.to_s << ":" if e
    ver << v << "-"
    ver << r
  else
    ver = argv
  end
end

# main
if $0 == __FILE__

  if ARGV.size < 2
    STDERR.puts USAGE
    exit 1
  end

  ver_1 = argv_ver(ARGV[0])
  ver_2 = argv_ver(ARGV[1])

  cmp = RPM::vercmp(ver_1, ver_2)
  if cmp == 0
    puts ver_1
  elsif cmp > 0
    puts ver_1
  elsif cmp < 0
    puts ver_2
  end

end
